<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Task 77.20</title>
  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback" />
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css" />
  <!-- DataTables -->
  <link rel="stylesheet" href="plugins/datatables-bs4/css/dataTables.bootstrap4.min.css" />
  <link rel="stylesheet" href="plugins/datatables-responsive/css/responsive.bootstrap4.min.css" />
  <link rel="stylesheet" href="plugins/datatables-buttons/css/buttons.bootstrap4.min.css" />
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css" />
  <style>
    i {
      cursor: pointer;
    }
  </style>
</head>

<body>
  <div class="wrapper">

    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
      </ul>

      <!-- Right navbar links -->
      <ul class="navbar-nav ml-auto">
        <!-- Navbar Search -->
        <li class="nav-item">
          <a class="nav-link" data-widget="navbar-search" href="#" role="button">
            <i class="fas fa-search"></i>
          </a>
          <div class="navbar-search-block">
            <form class="form-inline">
              <div class="input-group input-group-sm">
                <input class="form-control form-control-navbar" type="search" placeholder="Search"
                  aria-label="Search" />
                <div class="input-group-append">
                  <button class="btn btn-navbar" type="submit">
                    <i class="fas fa-search"></i>
                  </button>
                  <button class="btn btn-navbar" type="button" data-widget="navbar-search">
                    <i class="fas fa-times"></i>
                  </button>
                </div>
              </div>
            </form>
          </div>
        </li>

        <!-- Messages Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-comments"></i>
            <span class="badge badge-danger navbar-badge">3</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user1-128x128.jpg" alt="User Avatar" class="img-size-50 mr-3 img-circle" />
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Brad Diesel
                    <span class="float-right text-sm text-danger"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">Call me whenever you can...</p>
                  <p class="text-sm text-muted">
                    <i class="far fa-clock mr-1"></i> 4 Hours Ago
                  </p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user8-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3" />
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    John Pierce
                    <span class="float-right text-sm text-muted"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">I got your message bro</p>
                  <p class="text-sm text-muted">
                    <i class="far fa-clock mr-1"></i> 4 Hours Ago
                  </p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <!-- Message Start -->
              <div class="media">
                <img src="dist/img/user3-128x128.jpg" alt="User Avatar" class="img-size-50 img-circle mr-3" />
                <div class="media-body">
                  <h3 class="dropdown-item-title">
                    Nora Silvester
                    <span class="float-right text-sm text-warning"><i class="fas fa-star"></i></span>
                  </h3>
                  <p class="text-sm">The subject goes here</p>
                  <p class="text-sm text-muted">
                    <i class="far fa-clock mr-1"></i> 4 Hours Ago
                  </p>
                </div>
              </div>
              <!-- Message End -->
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Messages</a>
          </div>
        </li>
        <!-- Notifications Dropdown Menu -->
        <li class="nav-item dropdown">
          <a class="nav-link" data-toggle="dropdown" href="#">
            <i class="far fa-bell"></i>
            <span class="badge badge-warning navbar-badge">15</span>
          </a>
          <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
            <span class="dropdown-item dropdown-header">15 Notifications</span>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-envelope mr-2"></i> 4 new messages
              <span class="float-right text-muted text-sm">3 mins</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-users mr-2"></i> 8 friend requests
              <span class="float-right text-muted text-sm">12 hours</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item">
              <i class="fas fa-file mr-2"></i> 3 new reports
              <span class="float-right text-muted text-sm">2 days</span>
            </a>
            <div class="dropdown-divider"></div>
            <a href="#" class="dropdown-item dropdown-footer">See All Notifications</a>
          </div>
        </li>
        <li class="nav-item">
          <a class="nav-link" data-widget="fullscreen" href="#" role="button">
            <i class="fas fa-expand-arrows-alt"></i>
          </a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->
    <!-- Main Sidebar Container -->
    <aside style="min-height: 100vh;" class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user panel (optional) -->
        <div class="info">
          <a href="#" class="d-block text-center">DEV CAMP</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-th"></i>
              <p>
                Manage
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="Customer.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Customer</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="payment.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Payment</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="order.html" class="nav-link ">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Order</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="orderdetail.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Order Detail</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="product.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Product</p>
                </a>
              </li>

              <li class="nav-item">
                <a href="productline.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Product Line</p>
                </a>
              </li>

              <li class="nav-item">
                <a href="employee.html" class="nav-link ">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Employee</p>
                </a>
              </li>

              <li class="nav-item">
                <a href="office.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Office</p>
                </a>
              </li>
            </ul>
          </li>
          <!--  -->
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
  </div>
  <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">Office</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Office</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="container">
          <h3 class="text-center text-primary">Quản lý Office</h3>
          <div class="jumbotron">
            <div class="row form-group">
              <label for="" class="col-sm-3">City</label>
              <div class="col-sm-9">
                <input id="inp-city" type="text" class="form-control">
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">Phone</label>
              <div class="col-sm-9">
                <input id="inp-phone" type="text" class="form-control">
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">Address Line</label>
              <div class="col-sm-9">
                <input id="inp-address-line" type="text" class="form-control">
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">State</label>
              <div class="col-sm-9">
                <input id="inp-state" type="text" class="form-control">
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">Country</label>
              <div class="col-sm-9">
                <input id="inp-country" type="text" class="form-control">
              </div>
            </div>

            <div class="row form-group">
              <label for="" class="col-sm-3">Territory</label>
              <div class="col-sm-9">
                <input id="inp-territory" type="text" class="form-control">
              </div>
            </div>



            <button id="btn-add" class="btn btn-success">Thêm mới</button>
            <button id="btn-update" class="btn btn-primary" style="display: none;">Cập nhật</button>
            <button id="btn-delete" class="btn btn-danger" style="display: none;">Xóa</button>

          </div>


        </div>
        <table class="table table-bordered table-striped table-hover text-center" id="table-office">
          <thead>
            <tr>
              <th>ID</th>
              <th>City</th>
              <th>Phone</th>
              <th>Address Line</th>
              <th>State</th>
              <th>Country</th>
              <th>Territory</th>
            </tr>
          </thead>
          <tbody></tbody>
        </table>
        <!-- Modal delete region-->
        <div class="modal fade" id="modal-delete">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title text-danger">Xóa thông tin Office</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <h6>Bạn có chắc muốn xóa thông tin Office này?</h6>
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-danger" id="btn-delete-office">
                  Xác nhận
                </button>
                <button type="button" class="btn btn-secondary" data-dismiss="modal">
                  Hủy bỏ
                </button>

              </div>
            </div>
          </div>
        </div>


      </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
    <!-- /.content-wrapper -->
  </div>
  </div>
  <footer class="main-footer">
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
    All rights reserved.
    <div class="float-right d-none d-sm-inline-block">
      <b>Version</b> 3.1.0
    </div>
  </footer>
  <!-- jQuery -->
  <script src="plugins/jquery/jquery.min.js"></script>
  <!-- jQuery UI 1.11.4 -->
  <script src="plugins/jquery-ui/jquery-ui.min.js"></script>
  <!-- Bootstrap 4 -->
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!-- DataTables  & Plugins -->
  <script src="plugins/datatables/jquery.dataTables.min.js"></script>
  <script src="plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.js"></script>
  <script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gStt = 1;
    var gTableOffices = $("#table-office").DataTable({
      columns: [
        { data: "id" },
        { data: "city" },
        { data: "phone" },
        { data: "addressLine" },
        { data: "state" },
        { data: "country" },
        { data: "territory" }
      ]
    });

    var gOfficeId = null;
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    onPageLoading();

    // Thực thi sự kiện nhấn vào row product
    $("#table-office").on("click", "tr", function () {
      onRowEmployeeClick(this);
    });

    // Thực thi sự kiện nhấn nút tạo mới payment
    $("#btn-add").on("click", function () {
      onBtnCreateClick();
    })

    // Thực thi sự kiện nhấn nút cập nhật payment
    $("#btn-update").on("click", function () {
      onBtnUpdateClick();
    });

    // Thực thi sự kiện nhấn nút xóa 
    $("#btn-delete").on("click", function () {
      $("#modal-delete").modal("show");
    });

    // Thực thi sự kiện nhấn nút xác nhận xóa trong  modal delete
    $("#btn-delete-office").on("click", function () {
      onBtnConfirmDeleteClick();
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm xử lý sự kiện tải trang
    function onPageLoading() {
      callApiToLoadListOffices();
    }

    // Hàm xử lý sự kiện nhấn vào row của customre
    function onRowEmployeeClick(paramRow) {
      var vDataRow = gTableOffices.row(paramRow).data();
      gOfficeId = vDataRow.id;
      loadDataRowToForm(vDataRow);
    }


    // Hàm xử lý sự kiện nhấn nút tạo mới khách hàng
    function onBtnCreateClick() {
      var vEmployeeData = {
        lastName: "",
        firstName: "",
        extension: "",
        email: "",
        officeCode: "",
        reportTo: "",
        jobTitle: ""
      }

      getData(vEmployeeData);
      console.log(vEmployeeData);
      var vValidate = validateData(vEmployeeData);
      if (vValidate) {
        callApiToCreateEmployee(vEmployeeData);
      }
    }

    // Hàm xử lý sự kiện nhấn nút cập nhật thông tin khách hàng
    function onBtnUpdateClick() {
      var vProductLineData = {
        productLine: "",
        description: ""
      }

      getData(vProductLineData);
      console.log(vProductLineData);
      var vValidate = validateData(vProductLineData);
      if (vValidate) {
        callApiToUpdateProductLine(vProductLineData);
      }
    }

    // Hàm xử lý sự kiện nhấn nút xóa thông tin công ty
    function onBtnConfirmDeleteClick() {
      $.ajax({
        type: "DELETE",
        url: "http://localhost:8080/offices/" + gOfficeId,
        success: function (paramRes) {
          alert("Xóa thành công!");
          resetForm();
          callApiToLoadListOffices();
          $("#modal-delete").modal("hide");
        },
        error: function (paramError) {
          alert("Xóa thất bại, vui lòng thử lại!");
          console.log(paramError.status);
          $("#modal-delete").modal("hide");

        }
      })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm gọi API để load toàn bộ dữ liệu nhân viên vào bảng
    function callApiToLoadListOffices() {
      $.ajax({
        type: "GET",
        url: "http://localhost:8080/offices",
        success: function (paramRes) {
          console.log(paramRes);
          loadDataToTable(paramRes);
        },
        error: function (paramError) {
          console.log(paramError.status);
        }
      })
    }

    // Hàm load dữ liệu vào bảng
    function loadDataToTable(paramData) {
      gTableOffices.clear();
      gTableOffices.rows.add(paramData);
      gTableOffices.draw();
    }


    // Hàm load dữ liệu khách hàng vào form
    function loadDataRowToForm(paramDataRow) {
      console.log(paramDataRow);
      $("#inp-city").val(paramDataRow.city);
      $("#inp-phone").val(paramDataRow.phone);
      $("#inp-address-line").val(paramDataRow.addressLine);
      $("#inp-state").val(paramDataRow.state);
      $("#inp-country").val(paramDataRow.country);
      $("#inp-territory").val(paramDataRow.territory);

      $("#btn-add").hide();
      $("#btn-update").show();
      $("#btn-delete").show();
    }

    // Hàm lấy thông tin từ form
    function getData(paramDataRow) {
      paramDataRow.city = $("#inp-city").val();
      paramDataRow.phone = $("#inp-phone").val();
      paramDataRow.addressLine = $("#inp-address-line").val();
      paramDataRow.state = $("#inp-state").val();
      paramDataRow.country = $("#inp-country").val();
      paramDataRow.territory = $("#inp-territory").val();
    }

    // Hàm validate dữ liệu
    function validateData(paramEmployeeData) {
      if (paramEmployeeData.city == "") {
        alert("Vui lòng nhập city");
        return false;
      }

      if (paramEmployeeData.phone == "") {
        alert("Vui lòng nhập số điện thoại");
        return false;
      }

      if (paramEmployeeData.addressLine == "") {
        alert("Vui lòng nhập địa chỉ");
        return false;
      }

      if (paramEmployeeData.state == "") {
        alert("Vui lòng nhập state");
        return false;
      }

      if (paramEmployeeData.country == "") {
        alert("Vui lòng nhập country");
        return false;
      }

      if (paramEmployeeData.territory == "") {
        alert("Vui lòng nhập territory");
        return false;
      }
      return true;
    }

    // Hàm gọi API tạo mới employee
    function callApiToCreateEmployee(paramEmployee) {
      $.ajax({
        type: "POST",
        url: "http://localhost:8080/offices/",
        contentType: "application/json",
        data: JSON.stringify(paramEmployee),
        success: function (paramRes) {
          alert("Tạo mới thành công");
          callApiToLoadListOffices();
          resetForm();
        },
        error: function (paramError) {
          alert("Tạo mới thất bại, vui lòng thử lại!");
          console.log(paramError.status);
        }
      });
    }


    // Hàm gọi API update product
    function callApiToUpdateProductLine(paramProductLine) {
      $.ajax({
        type: "PUT",
        url: "http://localhost:8080/offices/" + gOfficeId,
        contentType: "application/json",
        data: JSON.stringify(paramProductLine),
        success: function (paramRes) {
          alert("Cập nhật thành công");
          callApiToLoadListOffices();
          resetForm();
        },
        error: function (paramError) {
          alert("Cập nhật thất bại, vui lòng thử lại!");
          console.log(paramError.status);
        }
      });
    }

    // Hàm reset form
    function resetForm() {
      $("#inp-city").val("");
      $("#inp-phone").val("");
      $("#inp-address-line").val("");
      $("#inp-state").val("");
      $("#inp-country").val("");
      $("#inp-territory").val("");


      $("#btn-add").show();
      $("#btn-update").hide();
      $("#btn-delete").hide();
    }
  </script>
</body>

</html>